class_name Player extends CharacterBody3D

@export var walk_speed: float = 4.0
@export var run_speed: float = 6.0

@onready var input = $Input
@onready var interactor = $Interactor

var is_carrying_item = false

func _ready() -> void:
    input.connect("interact", _on_interact)

func _physics_process(delta: float) -> void:
  move_and_rotate(delta)

func move_and_rotate(_delta: float):
  var speed = run_speed if input.is_running else walk_speed
  velocity = input.next_velocity(speed)
  if !velocity.is_zero_approx():
    look_at(global_position + velocity, Vector3.UP, true)
  move_and_slide()

func _on_interact():
    interactor.interact_nearest()

func on_save():
    return {
        position = position,
        rotation = rotation
    }

func on_before_load():
    pass

func on_load(data: Dictionary):
    position = data.position
    rotation = data.rotation
