class_name PlayerInput extends Node

signal run
signal interact

var is_running: bool = false
var is_interacting: bool = false

var movement_dir: Vector2:
  get: return Input.get_vector(
      'move_left', 'move_right',
      'move_up', 'move_down'
    ).normalized()

func _process(_delta: float) -> void:
    var running = Input.is_action_pressed("run")
    if running != is_running:
        run.emit(running)
        is_running = running

    var was_interacting = is_interacting
    is_interacting = Input.is_action_pressed("interact")

    if is_interacting and not was_interacting:
        interact.emit()

func next_velocity(speed: float, dir: Vector2 = movement_dir) -> Vector3:
  return Vector3(dir.x, 0, dir.y) * speed
